﻿using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class TaskBookBehavior_63002 : BaseTaskBookBehaviorV2
    {
        public TaskBookBehavior_63002() : base(63002, "库位取货")
        {
        }

        public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        {
            try
            {
                var result = Crms.PmsTaskService.StockMoveLocationToAgv(taskDetailInfo, stepInfo, out var message);
                if (result)
                {
                    //灭叫料盒灯
                    int route = stepInfo.WareHouseID.GetLocationMember("放行任务路线").ToValue<int>();
                    if (route > 0)
                    {
                        for (int i = 0; i < 2; i++)
                        {
                            DeviceControl.Instance.CallBoxLightOff(route);
                            System.Threading.Thread.Sleep(100);
                        }
                    }
                }

                Log(taskDetailInfo, stepInfo, message);
                return result;
            }
            catch (Exception ex)
            {
                LogException(ex);
            }
            return false;
        }
    }
}
