﻿using DbCommon.BusinessCore.BaseCore;
using HslCommunication;
using ICSharpCode.SharpZipLib.Zip;
using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessCallTask9015 : ICustomProcess
    {
        LocationPropertyManager m_locationManager = new LocationPropertyManager();
        string _呼叫AGV = "呼叫AGV";
        string _二维码 = "二维码(PLC)";
        string _响应呼叫 = "响应呼叫";
        string _请求下料 = "请求下料(AGV)";
        string _开始下料 = "开始下料(PLC)";
        string _收料完成 = "收料完成(AGV)";
        string _下料完成 = "下料完成(PLC)";
        public void CustomProcess(List<TaskData> taskDataList)
        {
            var RouteConfigList = ExcelConfig.Instance.RouteConfigList;
            foreach (var routeConfig in RouteConfigList)
            {
                bool taskToLocation = taskDataList != null && taskDataList.Any(p => p.TaskState != ETaskState.Canceled && p.TaskState != ETaskState.Cancel && p.AllWarehouse.Contains(routeConfig.LocationCode));
                if (taskToLocation)
                {
                    continue;
                }
                string tempCallFeedbackDB = routeConfig.LocationCode.GetPlcTaskAddr(_响应呼叫);
                string temp请求下料DB = routeConfig.LocationCode.GetPlcTaskAddr(_请求下料);
                string temp收料完成DB = routeConfig.LocationCode.GetPlcTaskAddr(_收料完成);
                if (!string.IsNullOrEmpty(tempCallFeedbackDB) && !string.IsNullOrWhiteSpace(tempCallFeedbackDB))
                {

                    var plc = routeConfig.PlcReadWrite;
                    OperateResult<Int16> operateResult = plc.ReadInt16(tempCallFeedbackDB);
                    if (operateResult.IsSuccess && operateResult.Content != 0)
                    {
                        plc.Write(tempCallFeedbackDB, (short)0);
                    }
                    OperateResult<Int16> operateResult1 = plc.ReadInt16(temp请求下料DB);
                    if (operateResult1.IsSuccess && operateResult1.Content != 0)
                    {
                        plc.Write(temp请求下料DB, (short)0);
                    }
                    OperateResult<Int16> operateResult2 = plc.ReadInt16(temp收料完成DB);
                    if (operateResult2.IsSuccess && operateResult2.Content != 0)
                    {
                        plc.Write(temp收料完成DB, (short)0);
                    }
                }
            }
            var FullBoxCallRouteConfigList = ExcelConfig.Instance.RouteConfigList.Where(d => d.WareHouseCode.Contains("满盘下料")).ToList();//|| d.WareHouseCode.Contains("空盘取盘")
            if (FullBoxCallRouteConfigList != null)
            {
                var agvDataList = Crms.PmsApi.GetAllCarrier();
                if (agvDataList != null)
                {
                    foreach (var routeConfig in FullBoxCallRouteConfigList)
                    {
                        bool taskToFullBoxUpLocation = taskDataList != null && taskDataList.Any(p => p.CurrentStepID < 9 && p.StepList != null && p.StepList.Count > 0 && p.StepList[0].WareHouseID == routeConfig.LocationCode);
                        if (!taskToFullBoxUpLocation)
                        {
                            if (!string.IsNullOrEmpty(routeConfig.PlcIpAddr) && !string.IsNullOrWhiteSpace(routeConfig.PlcIpAddr))
                            {
                                string tempCallAGVDB = routeConfig.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                                string tempQRCodeDB = routeConfig.LocationCode.GetPlcTaskAddr(_二维码);
                                var plc = routeConfig.PlcReadWrite;
                                if (!string.IsNullOrEmpty(tempCallAGVDB) && !string.IsNullOrWhiteSpace(tempCallAGVDB))
                                {
                                    OperateResult<Int16> operateResult = plc.ReadInt16(tempCallAGVDB);
                                    if (operateResult.IsSuccess && operateResult.Content == 100)
                                    {
                                        Log($"{routeConfig.LocationCode}呼叫AGV取满料，{tempCallAGVDB}值:100 ");
                                        if (Crms.PmsTaskService.LocationHasStepTask(routeConfig.LocationCode, out var tasklist))
                                        {
                                            Log($"{routeConfig.LocationCode} 已存AGV取满料任务 ");
                                            continue;
                                        }
                                        string nextlocation = routeConfig.LocationCode.GetLocationMember("下个工位");
                                        //string nextlocation = data.attribute1;
                                        if (string.IsNullOrEmpty(nextlocation) || string.IsNullOrWhiteSpace(nextlocation))
                                        {
                                            Log($"{routeConfig.LocationCode} 下个工位未配置 ");
                                        }
                                        if (ExcelConfig.Instance.RouteConfigDictionary.Keys.Contains(nextlocation))
                                        {
                                            var config = ExcelConfig.Instance.RouteConfigDictionary[nextlocation];
                                            if (!string.IsNullOrEmpty(config.PlcIpAddr))
                                            {
                                                var plcTargetLocation = config.PlcReadWrite;
                                                string tempCallDB = config.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                                                OperateResult<Int16> operateResultCall = plcTargetLocation.ReadInt16(tempCallDB);
                                                if (operateResultCall.IsSuccess && operateResultCall.Content == 100)
                                                {
                                                    Log($"{config.LocationCode}呼叫AGV送满料，{tempCallDB}值:100 ");
                                                }
                                                else
                                                {
                                                    Log($"{config.LocationCode}未呼叫AGV送满料，通信:{operateResultCall.IsSuccess},{tempCallDB}值:{operateResultCall.Content} ");
                                                    continue;
                                                }
                                            }
                                        }
                                        PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                                        data2.LocationCode = routeConfig.LocationCode;
                                        data2.TargetLocationCode = nextlocation;
                                        data2.CarrierType = nextlocation.Contains("陶瓷") || data2.LocationCode.Contains("陶瓷") ? "0" : "1";
                                        data2.TemplateName= routeConfig.LocationCode.GetLocationMember("后任务模板");
                                        //data2.Carrier = agvData.AgvID;
                                        var res2 = Crms.PmsTaskService.TaskAddNoCheck(data2, new string[] { });
                                        if (res2?.code == 20000)
                                        {
                                            //发出响应
                                            Thread.Sleep(2000);
                                        }
                                        Log($"添加任务【{data2.TaskID}】结果：{res2.message} 返回代码{res2.code}");
                                    }
                                    else
                                    {

                                    }
                                }
                            }
                        }
                    }
                }
            }

            var EmptyBoxCallRouteConfigList = ExcelConfig.Instance.RouteConfigList.Where(d => d.WareHouseCode.Contains("空盘上料")).ToList();
            if (EmptyBoxCallRouteConfigList != null)
            {
                var agvDataList = Crms.PmsApi.GetAllCarrier();
                if (agvDataList != null)
                {
                    foreach (var routeConfig in EmptyBoxCallRouteConfigList)
                    {
                        if (!string.IsNullOrEmpty(routeConfig.PlcIpAddr) && !string.IsNullOrWhiteSpace(routeConfig.PlcIpAddr))
                        {
                            string tempCallAGVDB = routeConfig.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                            string tempQRCodeDB = routeConfig.LocationCode.GetPlcTaskAddr(_二维码);
                            string tempCallFeedbackDB = routeConfig.LocationCode.GetPlcTaskAddr(_响应呼叫);
                            var plc = routeConfig.PlcReadWrite;
                            if (!string.IsNullOrEmpty(tempCallAGVDB) && !string.IsNullOrWhiteSpace(tempCallAGVDB))
                            {
                                OperateResult<Int16> operateResult = plc.ReadInt16(tempCallAGVDB);
                                if (operateResult.IsSuccess && operateResult.Content == 100)
                                {
                                    Log($"{routeConfig.LocationCode}呼叫AGV送空盘，{tempCallAGVDB}值:100 ");
                                    if (Crms.PmsTaskService.LocationHasStepTask(routeConfig.LocationCode, out var tasklist))
                                    {
                                        Log($"{routeConfig.LocationCode} 已存在AGV送空盘任务 ");
                                        continue;
                                    }
                                    string nextlocation = routeConfig.LocationCode.GetLocationMember("下个工位");
                                    if (string.IsNullOrEmpty(nextlocation) || string.IsNullOrWhiteSpace(nextlocation))
                                    {
                                        Log($"{routeConfig.LocationCode} 下个工位未配置 ");
                                    }
                                    if (ExcelConfig.Instance.RouteConfigDictionary.Keys.Contains(nextlocation))
                                    {
                                        var config = ExcelConfig.Instance.RouteConfigDictionary[nextlocation];
                                        if (!string.IsNullOrEmpty(config.PlcIpAddr))
                                        {
                                            var plcTargetLocation = config.PlcReadWrite;
                                            string tempCallDB = config.LocationCode.GetPlcTaskAddr(_呼叫AGV);
                                            OperateResult<Int16> operateResultCall = plcTargetLocation.ReadInt16(tempCallDB);
                                            if (operateResultCall.IsSuccess && operateResultCall.Content == 100)
                                            {
                                                Log($"{config.LocationCode}呼叫AGV取空盘，{tempCallDB}值:100 ");
                                            }
                                            else
                                            {
                                                Log($"{config.LocationCode}未AGV取空盘，通信:{operateResultCall.IsSuccess},{tempCallDB}值:{operateResultCall.Content} ");
                                                continue;
                                            }
                                        }
                                    }
                                    PmsTaskInfoDto data2 = new PmsTaskInfoDto();
                                    data2.LocationCode = nextlocation;
                                    data2.TargetLocationCode = routeConfig.LocationCode;
                                    data2.CarrierType = nextlocation.Contains("陶瓷") || data2.LocationCode.Contains("陶瓷") ? "0" : "1";
                                    //data2.Carrier = agvData.AgvID;
                                    data2.TemplateName = nextlocation.GetLocationMember("后任务模板");
                                    var res2 = Crms.PmsTaskService.TaskAddNoCheck(data2, new string[] { });
                                    if (res2?.code == 20000)
                                    {
                                        //发出响应
                                        if (!string.IsNullOrEmpty(tempCallFeedbackDB) && !string.IsNullOrWhiteSpace(tempCallFeedbackDB))
                                        {
                                            OperateResult<Int16> operateResult3 = plc.ReadInt16(tempCallFeedbackDB);
                                            if (operateResult3.IsSuccess && operateResult3.Content != 100)
                                            {
                                                plc.Write(tempCallFeedbackDB, (short)100);
                                            }
                                        }
                                        Thread.Sleep(2000);
                                    }
                                    Log($"添加任务【{data2.TaskID}】结果：{res2.message} 返回代码{res2.code}");
                                }
                                else
                                {
                                }
                            }
                        }
                    }
                }

            }

        }


        public bool CheckIsRepair(string locationcode)
        {
            var routeConfig = ExcelConfig.Instance.GetRouteConfig(locationcode);
            var plcaddress = locationcode.GetLocationMember("PLC返修");
            if (plcaddress != null && routeConfig.PlcReadWrite != null)
            {
                var result = routeConfig.PlcReadWrite.ReadBool(plcaddress);
                if (result.IsSuccess && result.Content)
                {
                    Log($"收到返修信号{locationcode}，下发返修任务");
                    return true;
                }
            }
            return false;
        }
        protected virtual bool CheckAllowEnter(string location)
        {
            //string agvRequestEnter = location.GetLocationMember("AGV请求进入");
            //if (!string.IsNullOrEmpty(agvRequestEnter))
            //{
            //    //如果有AGV请求，那任务所有工位都可以进入
            //    return true;
            //}

            string plcAllowEnter = location.GetLocationMember("PLC允许进入");
            if (string.IsNullOrEmpty(plcAllowEnter))
            {
                return true;
            }

            var config = ExcelConfig.Instance.GetRouteConfig(location);
            if (config == null
            || config.PlcReadWrite == null
            )//|| config.PlcConnected == false
            {
                return false;
            }

            OperateResult<Int16> read = config.PlcReadWrite.ReadInt16(plcAllowEnter);
            return read.IsSuccess && read.Content == 1;
        }

        private bool CheckNoTask(string location, TaskData taskDetailInfo, List<TaskData> taskDataList)
        {
            //查找结束点是当前工位的任务
            var taskDataFind = taskDataList.FirstOrDefault(d =>
            {
                //不算自身任务
                //if (d.TaskID == taskDetailInfo.TaskID) return false;

                var step = d.StepList?.OrderBy(s => s.StepID);
                var firstPos = step?.First()?.WareHouseID;
                var lastPos = step?.Last()?.WareHouseID;

                //不算放行任务
                if (firstPos != lastPos)
                {
                    if (firstPos == location)
                    {
                        return false;
                    }
                }

                //正在执行步骤的位置
                var currentPos = d.GetCurrentStepInfo()?.WareHouseID;
                return currentPos == location;
            });

            return taskDataFind == null;
        }

        private bool CheckNoAgv(string location)
        {
            var ignoreCheck = location.GetLocationMember("忽略检查工位AGV").ToValue<bool>();
            if (ignoreCheck)
            {
                return true;
            }

            var sDict = PackControl.Instance.StationDictionary;
            return sDict.TryGetValue(location, out var station) && !station.区域有Agv;
        }

        string lastMsg = "";
        public void Log(string msg, bool isDebug = false)
        {
            if (msg == lastMsg) return;

            lastMsg = msg;
            if (isDebug)
                CLog.Instance.TaskLog.WriteDebug(msg);
            else
                CLog.Instance.TaskLog.WriteInfo(msg);
        }
    }
}



