﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessPlcTask9018 : ICustomProcess
    {
        private List<RouteConfig> routeConfigs = ExcelConfig.Instance.RouteConfigList
            .Where(d => d.WareHouseCode == "输送线")
            .ToList();
        string _Address送货请求_输送线 = "送货请求(输送线)";
        string _Address送货托盘号_输送线 = "送货托盘号(输送线)";//int
        string _Address送货去向号_输送线 = "送货去向号(输送线)";//short

        string _Address送货托盘号_AGV = "送货托盘号(AGV)";//int
        string _Address送货去向号_AGV = "送货去向号(AGV)";//int
        public void CustomProcess(List<TaskData> taskDataList)
        {
            //站状态，0空，1有物料车，2满料。
            //模组型号，1   1p8s，2  1p13s，  3   ctp
            //1和2 c和d都可以进，3只能去人工位
            //var taskDataList = Crms.PmsApi.GetTaskDataList();
            if(taskDataList==null)
            {
                return;
            }
            foreach (var item in routeConfigs)
            {
                var taskDataListRealTime = Crms.PmsApi.GetTaskDataList();
                if (taskDataList == null)
                {
                    break;
                }
                string plcAddr送货托盘号_AGV = item.LocationCode.GetLocationMember(_Address送货托盘号_AGV);
                string plcAddr送货去向号_AGV = item.LocationCode.GetLocationMember(_Address送货去向号_AGV);
                if (Crms.PmsTaskService.LocationHasStartStepTask(item.LocationCode, out string _))//有送货到该站点的任务
                {

                    var tempResult0= item.PlcReadWrite.Write(plcAddr送货托盘号_AGV, 1);
                    
                    continue;
                }
                else
                {
                    var tempResult0 = item.PlcReadWrite.Write(plcAddr送货托盘号_AGV, 0);
                    var tempResult01 = item.PlcReadWrite.Write(plcAddr送货去向号_AGV, (short)0);
                    if (!tempResult0.IsSuccess|| !tempResult01.IsSuccess)
                    {
                        continue;
                    }
                }

                string plcAddr送货请求_输送线 = item.LocationCode.GetLocationMember(_Address送货请求_输送线);
                string plcAddr送货托盘号_输送线 = item.LocationCode.GetLocationMember(_Address送货托盘号_输送线);
                string plcAddr送货去向号_输送线 = item.LocationCode.GetLocationMember(_Address送货去向号_输送线);

                if (string.IsNullOrEmpty(plcAddr送货请求_输送线) || string.IsNullOrEmpty(plcAddr送货去向号_输送线)|| string.IsNullOrEmpty(plcAddr送货托盘号_输送线))
                {
                    continue;
                }

                var tempResult = item.PlcReadWrite.ReadBool(plcAddr送货请求_输送线);
                if (!tempResult.IsSuccess || !tempResult.Content)
                {
                    continue;
                }

                var tempResult2 = item.PlcReadWrite.ReadInt32(plcAddr送货托盘号_输送线);
                if (!tempResult2.IsSuccess || tempResult2.Content <= 0 )
                {
                    continue;
                }

                var tempResult3 = item.PlcReadWrite.ReadInt16(plcAddr送货去向号_输送线);
                if (!tempResult3.IsSuccess || tempResult3.Content <= 0)
                {
                    continue;
                }

                if (Crms.PmsTaskService.LocationHasStartStepTask(item.LocationCode, out string _))
                {
                    continue;
                }
                string _ToLocation = "站点" + tempResult3.Content;

                if (!routeConfigs.Any(p => p.LocationCode == _ToLocation))
                {
                    continue;
                }

                //if (Crms.PmsTaskService.LocationHasStepTask(_ToLocation, out string _))
                //{
                //    continue;
                //}
                
                CLog.Instance.TaskLog.WriteInfo($"{item.LocationCode} 送货请求(输送线) {plcAddr送货请求_输送线}={tempResult.Content}; 送货托盘号(输送线) {plcAddr送货托盘号_输送线}={tempResult2.Content}; 送货去向号(输送线) {plcAddr送货去向号_输送线}={tempResult3.Content}");

                

                PmsTaskInfoDto data = new PmsTaskInfoDto();
                data.LocationCode = item.LocationCode;
                data.TargetLocationCode = _ToLocation;

                var res = Crms.PmsTaskService.TaskAddNoCheck(data, new string[] { });
                if (res?.code == 20000)
                {
                   
                }
                Log($"添加任务【{data.TaskID}】结果：{res.message} 返回代码{res.code}");
            }
        }

        string lastMsg = "";
        public void Log(string msg, bool isDebug = false)
        {
            if (msg == lastMsg) return;

            lastMsg = msg;
            if (isDebug)
                CLog.Instance.TaskLog.WriteDebug(msg);
            else
                CLog.Instance.TaskLog.WriteInfo(msg);
        }
    }
}

